"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import abc
import grpc
import luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2

class OnshapeServiceStub:
    """Public API service for Onshape third-party integration functionality.
    Exposes authentication status checking and variable fetching capabilities.
    """

    def __init__(self, channel: grpc.Channel) -> None: ...
    GetAuthenticationStatus: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.GetAuthenticationStatusRequest,
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.GetAuthenticationStatusReply,
    ]
    """Checks whether the current user has valid authentication with Onshape."""
    FetchVariables: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.FetchVariablesRequest,
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.FetchVariablesReply,
    ]
    """Fetches the list of variable names available in the specified Onshape element."""
    ListDocumentsWithWorkspaceAndVersions: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListDocumentsWithWorkspaceAndVersionsRequest,
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListDocumentsWithWorkspaceAndVersionsReply,
    ]
    """Lists the documents of the user and the associated workspaces and versions.
    A thumbnail is included for each document (not workspace or version)
    """
    ListDocuments: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListDocumentsRequest,
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListDocumentsReply,
    ]
    """Lists only the documents of the user. A thumbnail is included for each document."""
    ListWorkspacesAndVersions: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListWorkspacesAndVersionsRequest,
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListWorkspacesAndVersionsReply,
    ]
    """Lists the workspaces and versions for a given document."""
    ListImportablesForSelection: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListImportablesForSelectionRequest,
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListImportablesForSelectionReply,
    ]
    """Given a request specifying a document and a workspace or version, lists the importable elements."""
    GetCompanyPrefixes: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.GetCompanyPrefixesRequest,
        luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.GetCompanyPrefixesReply,
    ]
    """Returns information about the companies the user is associated with."""

class OnshapeServiceServicer(metaclass=abc.ABCMeta):
    """Public API service for Onshape third-party integration functionality.
    Exposes authentication status checking and variable fetching capabilities.
    """

    @abc.abstractmethod
    def GetAuthenticationStatus(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.GetAuthenticationStatusRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.GetAuthenticationStatusReply:
        """Checks whether the current user has valid authentication with Onshape."""
    @abc.abstractmethod
    def FetchVariables(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.FetchVariablesRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.FetchVariablesReply:
        """Fetches the list of variable names available in the specified Onshape element."""
    @abc.abstractmethod
    def ListDocumentsWithWorkspaceAndVersions(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListDocumentsWithWorkspaceAndVersionsRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListDocumentsWithWorkspaceAndVersionsReply:
        """Lists the documents of the user and the associated workspaces and versions.
        A thumbnail is included for each document (not workspace or version)
        """
    @abc.abstractmethod
    def ListDocuments(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListDocumentsRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListDocumentsReply:
        """Lists only the documents of the user. A thumbnail is included for each document."""
    @abc.abstractmethod
    def ListWorkspacesAndVersions(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListWorkspacesAndVersionsRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListWorkspacesAndVersionsReply:
        """Lists the workspaces and versions for a given document."""
    @abc.abstractmethod
    def ListImportablesForSelection(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListImportablesForSelectionRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.ListImportablesForSelectionReply:
        """Given a request specifying a document and a workspace or version, lists the importable elements."""
    @abc.abstractmethod
    def GetCompanyPrefixes(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.GetCompanyPrefixesRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.thirdpartyintegration.onshape.onshape_pb2.GetCompanyPrefixesReply:
        """Returns information about the companies the user is associated with."""

def add_OnshapeServiceServicer_to_server(servicer: OnshapeServiceServicer, server: grpc.Server) -> None: ...
