# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABC, ABCMeta
from dataclasses import dataclass, field
from typing import Any
from uuid import uuid4

from google.protobuf.message import Message as _Message
from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from luminarycloud.types import Vector3, LcFloat
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._helpers._entity_identifier import _create_entity_identifier
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
from luminarycloud._helpers import CodeRepr
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.simulation._lib import ParamGroupWrapper, create_unique_id


@dataclass(kw_only=True)
class BladeElementParams(CodeRepr):
    """"""

    rotation_rate: LcFloat = 100.0
    "Rotational speed of the fictitious blades represented by the actuator disk."
    bem_strategy: enum.ActuatorDiskBemStrategy = enum.ActuatorDiskBemStrategy.BEM_ROTATION_RATE
    "Defines how the power of the propeller is specified in the blade element model."
    blade_count: int = 2
    "Number of blades in the propeller/rotor."
    pitch_schedule: Vector3 = field(default_factory=lambda: Vector3(0.0, 0.0, 0.0))
    "Constant, cosine, and sine Fourier series coefficients for pitch first harmonic."
    blade_geometry_table: RectilinearTable | None = None
    "Blade twist, sweep, anhedral, and chord vs. radial station (r/R)."
    reference_sound_speed: LcFloat = 340.0
    "Reference sound speed required for each blade element model in constant density flows. Sound speed of air at sea level conditions is 340 m/s."
